Index: serefpolicy-contrib-20140730/ktalk.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/ktalk.fc
+++ serefpolicy-contrib-20140730/ktalk.fc
@@ -1,3 +1,5 @@
+/usr/lib/systemd/system/ntalk.*  --  gen_context(system_u:object_r:ktalkd_unit_file_t,s0)
+
 /usr/bin/ktalkd	--	gen_context(system_u:object_r:ktalkd_exec_t,s0)
 
 /usr/sbin/in\.talkd	--	gen_context(system_u:object_r:ktalkd_exec_t,s0)
Index: serefpolicy-contrib-20140730/ktalk.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ktalk.if
+++ serefpolicy-contrib-20140730/ktalk.if
@@ -1 +1,76 @@
-## <summary>KDE Talk daemon.</summary>
+
+## <summary>talk-server - daemon programs for the Internet talk </summary>
+
+########################################
+## <summary>
+##	Execute TEMPLATE in the ktalkd domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`ktalk_domtrans',`
+	gen_require(`
+		type ktalkd_t, ktalkd_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, ktalkd_exec_t, ktalkd_t)
+')
+########################################
+## <summary>
+##	Execute ktalkd server in the ktalkd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`ktalk_systemctl',`
+	gen_require(`
+		type ktalkd_t;
+		type ktalkd_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+    systemd_read_fifo_file_passwd_run($1)
+	allow $1 ktalkd_unit_file_t:file read_file_perms;
+	allow $1 ktalkd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, ktalkd_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an ktalkd environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`ktalk_admin',`
+	gen_require(`
+		type ktalkd_t;
+	    type ktalkd_unit_file_t;
+	')
+
+	allow $1 ktalkd_t:process { ptrace signal_perms };
+	ps_process_pattern($1, ktalkd_t)
+
+	ktalk_systemctl($1)
+	admin_pattern($1, ktalkd_unit_file_t)
+	allow $1 ktalkd_unit_file_t:service all_service_perms;
+
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
+')
Index: serefpolicy-contrib-20140730/ktalk.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ktalk.te
+++ serefpolicy-contrib-20140730/ktalk.te
@@ -1,4 +1,4 @@
-policy_module(ktalk, 1.10.0)
+policy_module(ktalk, 1.9.2)
 
 ########################################
 #
@@ -13,6 +13,9 @@ inetd_udp_service_domain(ktalkd_t, ktalk
 type ktalkd_log_t;
 logging_log_file(ktalkd_log_t)
 
+type ktalkd_unit_file_t;
+systemd_unit_file(ktalkd_unit_file_t)
+
 type ktalkd_tmp_t;
 files_tmp_file(ktalkd_tmp_t)
 
@@ -50,7 +53,8 @@ dev_read_urand(ktalkd_t)
 
 fs_getattr_xattr_fs(ktalkd_t)
 
-term_use_all_terms(ktalkd_t)
+term_search_ptys(ktalkd_t)
+term_use_all_inherited_terms(ktalkd_t)
 
 auth_use_nsswitch(ktalkd_t)
 
@@ -58,4 +62,5 @@ init_read_utmp(ktalkd_t)
 
 logging_send_syslog_msg(ktalkd_t)
 
-miscfiles_read_localization(ktalkd_t)
+userdom_use_user_ptys(ktalkd_t)
+userdom_use_user_ttys(ktalkd_t)
Index: serefpolicy-contrib-20140730/kudzu.if
===================================================================
--- serefpolicy-contrib-20140730.orig/kudzu.if
+++ serefpolicy-contrib-20140730/kudzu.if
@@ -86,9 +86,13 @@ interface(`kudzu_admin',`
 		type kudzu_tmp_t;
 	')
 
-	allow $1 kudzu_t:process { ptrace signal_perms };
+	allow $1 kudzu_t:process { signal_perms };
 	ps_process_pattern($1, kudzu_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 kudzu_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, kudzu_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 kudzu_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/kudzu.te
===================================================================
--- serefpolicy-contrib-20140730.orig/kudzu.te
+++ serefpolicy-contrib-20140730/kudzu.te
@@ -1,4 +1,4 @@
-policy_module(kudzu, 1.10.0)
+policy_module(kudzu, 1.9.0)
 
 ########################################
 #
@@ -47,9 +47,8 @@ kernel_read_device_sysctls(kudzu_t)
 kernel_read_kernel_sysctls(kudzu_t)
 kernel_read_network_state(kudzu_t)
 kernel_read_system_state(kudzu_t)
-kernel_rw_hotplug_sysctls(kudzu_t)
+kernel_rw_usermodehelper_state(kudzu_t)
 kernel_rw_kernel_sysctl(kudzu_t)
-kernel_dontaudit_search_unlabeled(kudzu_t)
 
 corecmd_exec_all_executables(kudzu_t)
 
@@ -64,7 +63,6 @@ dev_rwx_zero(kudzu_t)
 domain_use_interactive_fds(kudzu_t)
 
 files_read_kernel_modules(kudzu_t)
-files_read_usr_files(kudzu_t)
 files_search_locks(kudzu_t)
 files_manage_etc_files(kudzu_t)
 files_manage_etc_runtime_files(kudzu_t)
@@ -72,6 +70,7 @@ files_etc_filetrans_etc_runtime(kudzu_t,
 files_manage_mnt_files(kudzu_t)
 files_manage_mnt_symlinks(kudzu_t)
 files_dontaudit_search_src(kudzu_t)
+files_dontaudit_search_isid_type_dirs(kudzu_t)
 
 fs_search_auto_mountpoints(kudzu_t)
 fs_write_ramfs_sockets(kudzu_t)
@@ -101,11 +100,10 @@ libs_read_lib_files(kudzu_t)
 logging_send_syslog_msg(kudzu_t)
 
 miscfiles_read_hwdata(kudzu_t)
-miscfiles_read_localization(kudzu_t)
 
 sysnet_read_config(kudzu_t)
 
-userdom_use_user_terminals(kudzu_t)
+userdom_use_inherited_user_terminals(kudzu_t)
 userdom_dontaudit_use_unpriv_user_fds(kudzu_t)
 userdom_search_user_home_dirs(kudzu_t)
 
@@ -122,17 +120,9 @@ optional_policy(`
 ')
 
 optional_policy(`
-	nscd_use(kudzu_t)
-')
-
-optional_policy(`
 	seutil_sigchld_newrole(kudzu_t)
 ')
 
 optional_policy(`
 	udev_read_db(kudzu_t)
 ')
-
-optional_policy(`
-	unconfined_domtrans(kudzu_t)
-')
Index: serefpolicy-contrib-20140730/l2tp.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/l2tp.fc
+++ serefpolicy-contrib-20140730/l2tp.fc
@@ -5,6 +5,7 @@
 /etc/sysconfig/.*l2tpd	--	gen_context(system_u:object_r:l2tp_conf_t,s0)
 
 /usr/sbin/.*l2tpd	--	gen_context(system_u:object_r:l2tpd_exec_t,s0)
+/usr/libexec/nm-l2tp-service    --  gen_context(system_u:object_r:l2tpd_exec_t,s0)
 
 /var/run/.*l2tpd(/.*)?	gen_context(system_u:object_r:l2tpd_var_run_t,s0)
 /var/run/prol2tpd\.ctl	-s	gen_context(system_u:object_r:l2tpd_var_run_t,s0)
Index: serefpolicy-contrib-20140730/l2tp.if
===================================================================
--- serefpolicy-contrib-20140730.orig/l2tp.if
+++ serefpolicy-contrib-20140730/l2tp.if
@@ -1,9 +1,45 @@
-## <summary>Layer 2 Tunneling Protocol.</summary>
+## <summary>Layer 2 Tunneling Protocol daemons.</summary>
 
 ########################################
 ## <summary>
-##	Send to l2tpd with a unix
-##	domain dgram socket.
+##	Transition to l2tpd.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`l2tpd_domtrans',`
+	gen_require(`
+		type l2tpd_t, l2tpd_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, l2tpd_exec_t, l2tpd_t)
+')
+
+########################################
+## <summary>
+##	Execute l2tpd server in the l2tpd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_initrc_domtrans',`
+	gen_require(`
+		type l2tpd_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, l2tpd_initrc_exec_t)
+')
+
+########################################
+## <summary>
+##	Send to l2tpd via a unix dgram socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -16,7 +52,6 @@ interface(`l2tpd_dgram_send',`
 		type l2tpd_t, l2tpd_tmp_t, l2tpd_var_run_t;
 	')
 
-	files_search_pids($1)
 	files_search_tmp($1)
 	dgram_send_pattern($1, { l2tpd_tmp_t l2tpd_var_run_t }, { l2tpd_tmp_t l2tpd_var_run_t }, l2tpd_t)
 ')
@@ -39,10 +74,29 @@ interface(`l2tpd_rw_socket',`
 	allow $1 l2tpd_t:socket rw_socket_perms;
 ')
 
+########################################
+## <summary>
+##	Read l2tpd PID files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_read_pid_files',`
+	gen_require(`
+		type l2tpd_var_run_t;
+	')
+
+	files_search_pids($1)
+	allow $1 l2tpd_var_run_t:file read_file_perms;
+')
+
 #####################################
 ## <summary>
-##	Connect to l2tpd with a unix
-##	domain stream socket.
+##	Connect to l2tpd over a unix domain
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -56,14 +110,107 @@ interface(`l2tpd_stream_connect',`
 	')
 
 	files_search_pids($1)
-	files_search_tmp($1)
-	stream_connect_pattern($1, { l2tpd_tmp_t l2tpd_var_run_t }, { l2tpd_tmp_t l2tpd_var_run_t }, l2tpd_t)
+	stream_connect_pattern($1, l2tpd_tmp_t, l2tpd_tmp_t, l2tpd_t)
+	stream_connect_pattern($1, l2tpd_var_run_t, l2tpd_var_run_t, l2tpd_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an l2tp environment.
+##	Read and write l2tpd unnamed pipes.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_rw_pipes',`
+	gen_require(`
+		type l2tpd_t;
+	')
+
+	allow $1 l2tpd_t:fifo_file rw_fifo_file_perms;
+')
+
+########################################
+## <summary>
+##	Allow send a signal to l2tpd.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_signal',`
+	gen_require(`
+		type l2tpd_t;
+	')
+
+	allow $1 l2tpd_t:process signal;
+')
+
+########################################
+## <summary>
+##	Allow send signull to l2tpd.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_signull',`
+	gen_require(`
+		type l2tpd_t;
+	')
+
+	allow $1 l2tpd_t:process signull;
+')
+
+########################################
+## <summary>
+##	Allow send sigkill to l2tpd.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_sigkill',`
+	gen_require(`
+		type l2tpd_t;
+	')
+
+	allow $1 l2tpd_t:process sigkill;
+')
+
+########################################
+## <summary>
+##	Send and receive messages from
+##	l2tpd over dbus.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`l2tpd_dbus_chat',`
+	gen_require(`
+		type l2tpd_t;
+		class dbus send_msg;
+	')
+
+	allow $1 l2tpd_t:dbus send_msg;
+	allow l2tpd_t $1:dbus send_msg;
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an l2tpd environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -77,16 +224,20 @@ interface(`l2tpd_stream_connect',`
 ## </param>
 ## <rolecap/>
 #
-interface(`l2tp_admin',`
+interface(`l2tpd_admin',`
 	gen_require(`
 		type l2tpd_t, l2tpd_initrc_exec_t, l2tpd_var_run_t;
 		type l2tp_conf_t, l2tpd_tmp_t;
 	')
 
-	allow $1 l2tpd_t:process { ptrace signal_perms };
+	allow $1 l2tpd_t:process signal_perms;
 	ps_process_pattern($1, l2tpd_t)
 
-	init_labeled_script_domtrans($1, l2tpd_initrc_exec_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 l2tpd_t:process ptrace;
+	')
+
+	l2tpd_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 l2tpd_initrc_exec_t system_r;
 	allow $2 system_r;
Index: serefpolicy-contrib-20140730/l2tp.te
===================================================================
--- serefpolicy-contrib-20140730.orig/l2tp.te
+++ serefpolicy-contrib-20140730/l2tp.te
@@ -27,7 +27,7 @@ files_pid_file(l2tpd_var_run_t)
 #
 
 allow l2tpd_t self:capability net_admin;
-allow l2tpd_t self:process signal;
+allow l2tpd_t self:process signal_perms;
 allow l2tpd_t self:fifo_file rw_fifo_file_perms;
 allow l2tpd_t self:netlink_socket create_socket_perms;
 allow l2tpd_t self:rawip_socket create_socket_perms;
@@ -42,11 +42,13 @@ manage_dirs_pattern(l2tpd_t, l2tpd_var_r
 manage_files_pattern(l2tpd_t, l2tpd_var_run_t, l2tpd_var_run_t)
 manage_sock_files_pattern(l2tpd_t, l2tpd_var_run_t, l2tpd_var_run_t)
 manage_fifo_files_pattern(l2tpd_t, l2tpd_var_run_t, l2tpd_var_run_t)
-files_pid_filetrans(l2tpd_t, l2tpd_var_run_t, { dir file sock_file })
+files_pid_filetrans(l2tpd_t, l2tpd_var_run_t, { dir file sock_file fifo_file })
 
 manage_sock_files_pattern(l2tpd_t, l2tpd_tmp_t, l2tpd_tmp_t)
 files_tmp_filetrans(l2tpd_t, l2tpd_tmp_t, sock_file)
 
+can_exec(l2tpd_t, l2tpd_exec_t)
+
 corenet_all_recvfrom_unlabeled(l2tpd_t)
 corenet_all_recvfrom_netlabel(l2tpd_t)
 corenet_raw_sendrecv_generic_if(l2tpd_t)
@@ -75,19 +77,37 @@ corecmd_exec_bin(l2tpd_t)
 
 dev_read_urand(l2tpd_t)
 
-files_read_etc_files(l2tpd_t)
-
 term_setattr_generic_ptys(l2tpd_t)
 term_use_generic_ptys(l2tpd_t)
 term_use_ptmx(l2tpd_t)
 
-logging_send_syslog_msg(l2tpd_t)
+auth_read_passwd(l2tpd_t)
 
-miscfiles_read_localization(l2tpd_t)
+logging_send_syslog_msg(l2tpd_t)
 
 sysnet_dns_name_resolve(l2tpd_t)
 
 optional_policy(`
+    dbus_system_bus_client(l2tpd_t)
+    dbus_connect_system_bus(l2tpd_t)
+    
+    optional_policy(`
+        networkmanager_dbus_chat(l2tpd_t)
+    ')
+')
+
+optional_policy(`
+    ipsec_domtrans_mgmt(l2tpd_t)
+    ipsec_mgmt_read_pid(l2tpd_t)
+    ipsec_filetrans_key_file(l2tpd_t)
+    ipsec_manage_key_file(l2tpd_t)
+')
+
+optional_policy(`
+	networkmanager_read_pid_files(l2tpd_t)
+')
+
+optional_policy(`
 	ppp_domtrans(l2tpd_t)
 	ppp_signal(l2tpd_t)
 	ppp_kill(l2tpd_t)
Index: serefpolicy-contrib-20140730/ldap.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/ldap.fc
+++ serefpolicy-contrib-20140730/ldap.fc
@@ -1,8 +1,11 @@
 /etc/ldap/slapd\.conf	--	gen_context(system_u:object_r:slapd_etc_t,s0)
-/etc/openldap/certs(/.*)?	gen_context(system_u:object_r:slapd_cert_t,s0)
+
+/etc/openldap/certs(/.*)?   gen_context(system_u:object_r:slapd_cert_t,s0)
 /etc/openldap/slapd\.d(/.*)?	gen_context(system_u:object_r:slapd_db_t,s0)
 
-/etc/rc\.d/init\.d/ldap	--	gen_context(system_u:object_r:slapd_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/slapd	--	gen_context(system_u:object_r:slapd_initrc_exec_t,s0)
+
+/usr/lib/systemd/system/slapd.*	--	gen_context(system_u:object_r:slapd_unit_file_t,s0)
 
 /usr/sbin/slapd	--	gen_context(system_u:object_r:slapd_exec_t,s0)
 
@@ -22,8 +25,7 @@
 /var/log/ldap.*	gen_context(system_u:object_r:slapd_log_t,s0)
 /var/log/slapd.*	gen_context(system_u:object_r:slapd_log_t,s0)
 
-/var/run/ldapi	-s	gen_context(system_u:object_r:slapd_var_run_t,s0)
-/var/run/openldap(/.*)?	gen_context(system_u:object_r:slapd_var_run_t,s0)
-/var/run/slapd.*	-s	gen_context(system_u:object_r:slapd_var_run_t,s0)
-/var/run/slapd\.args	--	gen_context(system_u:object_r:slapd_var_run_t,s0)
-/var/run/slapd\.pid	--	gen_context(system_u:object_r:slapd_var_run_t,s0)
+/var/run/ldapi          -s      gen_context(system_u:object_r:slapd_var_run_t,s0)
+/var/run/openldap(/.*)?         gen_context(system_u:object_r:slapd_var_run_t,s0)
+/var/run/slapd\.args    --      gen_context(system_u:object_r:slapd_var_run_t,s0)
+/var/run/slapd\.pid     --      gen_context(system_u:object_r:slapd_var_run_t,s0)
Index: serefpolicy-contrib-20140730/ldap.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ldap.if
+++ serefpolicy-contrib-20140730/ldap.if
@@ -1,8 +1,68 @@
-## <summary>OpenLDAP directory server.</summary>
+## <summary>OpenLDAP directory server</summary>
+
+#######################################
+## <summary>
+##	Execute OpenLDAP in the ldap domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ldap_domtrans',`
+	gen_require(`
+		type slapd_t, slapd_exec_t;
+	')
+
+	domtrans_pattern($1, slapd_exec_t, slapd_t)
+')
+
+#######################################
+## <summary>
+##	Execute OpenLDAP server in the ldap domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ldap_initrc_domtrans',`
+	gen_require(`
+		type slapd_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, slapd_initrc_exec_t)
+')
+
+########################################
+## <summary>
+##	Execute slapd server in the slapd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`ldap_systemctl',`
+	gen_require(`
+		type slapd_unit_file_t;
+		type slapd_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 slapd_unit_file_t:file read_file_perms;
+	allow $1 slapd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, slapd_t)
+')
 
 ########################################
 ## <summary>
-##	List ldap database directories.
+##	Read the contents of the OpenLDAP
+##	database directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -15,13 +75,31 @@ interface(`ldap_list_db',`
 		type slapd_db_t;
 	')
 
-	files_search_etc($1)
 	allow $1 slapd_db_t:dir list_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read ldap configuration files.
+##	Read the contents of the OpenLDAP
+##	database files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ldap_read_db_files',`
+	gen_require(`
+		type slapd_db_t;
+	')
+
+	read_files_pattern($1, slapd_db_t, slapd_db_t)
+')
+
+########################################
+## <summary>
+##	Read the OpenLDAP configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -41,22 +119,29 @@ interface(`ldap_read_config',`
 
 ########################################
 ## <summary>
-##	Use LDAP over TCP connection.  (Deprecated)
+##	Read the OpenLDAP cert files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
-interface(`ldap_use',`
-	refpolicywarn(`$0($*) has been deprecated.')
+interface(`ldap_read_certs',`
+	gen_require(`
+		type slapd_cert_t;
+	')
+
+	files_search_etc($1)
+    allow $1 slapd_cert_t:dir list_dir_perms;
+    read_files_pattern($1, slapd_cert_t, slapd_cert_t)
+    read_lnk_files_pattern($1, slapd_cert_t, slapd_cert_t)
 ')
 
 ########################################
 ## <summary>
-##	Connect to slapd over an unix
-##	stream socket.
+##	Use LDAP over TCP connection.  (Deprecated)
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -64,18 +149,13 @@ interface(`ldap_use',`
 ##	</summary>
 ## </param>
 #
-interface(`ldap_stream_connect',`
-	gen_require(`
-		type slapd_t, slapd_var_run_t;
-	')
-
-	files_search_pids($1)
-	stream_connect_pattern($1, slapd_var_run_t, slapd_var_run_t, slapd_t)
+interface(`ldap_use',`
+	refpolicywarn(`$0($*) has been deprecated.')
 ')
 
 ########################################
 ## <summary>
-## 	Connect to ldap over the network.
+##	Connect to slapd over an unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -83,21 +163,19 @@ interface(`ldap_stream_connect',`
 ##	</summary>
 ## </param>
 #
-interface(`ldap_tcp_connect',`
+interface(`ldap_stream_connect',`
 	gen_require(`
-		type slapd_t;
+		type slapd_t, slapd_var_run_t;
 	')
 
-	corenet_sendrecv_ldap_client_packets($1)
-	corenet_tcp_connect_ldap_port($1)
-	corenet_tcp_recvfrom_labeled($1, slapd_t)
-	corenet_tcp_sendrecv_ldap_port($1)
+	files_search_pids($1)
+	stream_connect_pattern($1, slapd_var_run_t, slapd_var_run_t, slapd_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an ldap environment.
+##	All of the rules required to administrate
+##	an ldap environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -106,7 +184,7 @@ interface(`ldap_tcp_connect',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the ldap domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -117,11 +195,16 @@ interface(`ldap_admin',`
 		type slapd_lock_t, slapd_etc_t, slapd_var_run_t;
 		type slapd_initrc_exec_t, slapd_log_t, slapd_cert_t;
 		type slapd_db_t, slapd_keytab_t;
+		type slapd_unit_file_t;
 	')
 
-	allow $1 slapd_t:process { ptrace signal_perms };
+	allow $1 slapd_t:process signal_perms;
 	ps_process_pattern($1, slapd_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 slapd_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, slapd_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 slapd_initrc_exec_t system_r;
@@ -130,13 +213,9 @@ interface(`ldap_admin',`
 	files_list_etc($1)
 	admin_pattern($1, { slapd_etc_t slapd_db_t slapd_cert_t slapd_keytab_t })
 
-	files_list_locks($1)
 	admin_pattern($1, slapd_lock_t)
 
-	logging_list_logs($1)
-	admin_pattern($1, slapd_log_t)
-
-	files_search_var_lib($1)
+	files_list_var_lib($1)
 	admin_pattern($1, slapd_replog_t)
 
 	files_list_tmp($1)
@@ -144,4 +223,8 @@ interface(`ldap_admin',`
 
 	files_list_pids($1)
 	admin_pattern($1, slapd_var_run_t)
+
+	ldap_systemctl($1)
+	admin_pattern($1, slapd_unit_file_t)
+	allow $1 slapd_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/ldap.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ldap.te
+++ serefpolicy-contrib-20140730/ldap.te
@@ -1,4 +1,4 @@
-policy_module(ldap, 1.12.0)
+policy_module(ldap, 1.11.1)
 
 ########################################
 #
@@ -21,6 +21,9 @@ files_config_file(slapd_etc_t)
 type slapd_initrc_exec_t;
 init_script_file(slapd_initrc_exec_t)
 
+type slapd_unit_file_t;
+systemd_unit_file(slapd_unit_file_t)
+
 type slapd_keytab_t;
 files_type(slapd_keytab_t)
 
@@ -49,7 +52,7 @@ files_pid_file(slapd_var_run_t)
 
 allow slapd_t self:capability { kill setgid setuid net_raw dac_override dac_read_search };
 dontaudit slapd_t self:capability sys_tty_config;
-allow slapd_t self:process setsched;
+allow slapd_t self:process { setsched signal } ;
 allow slapd_t self:fifo_file rw_fifo_file_perms;
 allow slapd_t self:tcp_socket { accept listen };
 
@@ -69,9 +72,7 @@ allow slapd_t slapd_lock_t:file manage_f
 files_lock_filetrans(slapd_t, slapd_lock_t, file)
 
 manage_dirs_pattern(slapd_t, slapd_log_t, slapd_log_t)
-append_files_pattern(slapd_t, slapd_log_t, slapd_log_t)
-create_files_pattern(slapd_t, slapd_log_t, slapd_log_t)
-setattr_files_pattern(slapd_t, slapd_log_t, slapd_log_t)
+manage_files_pattern(slapd_t, slapd_log_t, slapd_log_t)
 logging_log_filetrans(slapd_t, slapd_log_t, { file dir })
 
 manage_dirs_pattern(slapd_t, slapd_replog_t, slapd_replog_t)
@@ -93,7 +94,6 @@ files_pid_filetrans(slapd_t, slapd_var_r
 kernel_read_system_state(slapd_t)
 kernel_read_kernel_sysctls(slapd_t)
 
-corenet_all_recvfrom_unlabeled(slapd_t)
 corenet_all_recvfrom_netlabel(slapd_t)
 corenet_tcp_sendrecv_generic_if(slapd_t)
 corenet_tcp_sendrecv_generic_node(slapd_t)
@@ -115,15 +115,14 @@ fs_getattr_all_fs(slapd_t)
 fs_search_auto_mountpoints(slapd_t)
 
 files_read_etc_runtime_files(slapd_t)
-files_read_usr_files(slapd_t)
 files_list_var_lib(slapd_t)
 
 auth_use_nsswitch(slapd_t)
+auth_rw_cache(slapd_t)
 
 logging_send_syslog_msg(slapd_t)
 
 miscfiles_read_generic_certs(slapd_t)
-miscfiles_read_localization(slapd_t)
 
 userdom_dontaudit_use_unpriv_user_fds(slapd_t)
 userdom_dontaudit_search_user_home_dirs(slapd_t)
@@ -131,9 +130,9 @@ userdom_dontaudit_search_user_home_dirs(
 optional_policy(`
 	kerberos_manage_host_rcache(slapd_t)
 	kerberos_read_keytab(slapd_t)
-	kerberos_tmp_filetrans_host_rcache(slapd_t, file, "ldapmap1_0")
-	kerberos_tmp_filetrans_host_rcache(slapd_t, file, "ldap_487")
-	kerberos_tmp_filetrans_host_rcache(slapd_t, file, "ldap_55")
+	kerberos_tmp_filetrans_host_rcache(slapd_t, "ldapmap1_0")
+	kerberos_tmp_filetrans_host_rcache(slapd_t, "ldap_487")
+	kerberos_tmp_filetrans_host_rcache(slapd_t, "ldap_55")
 	kerberos_use(slapd_t)
 ')
 
Index: serefpolicy-contrib-20140730/lightsquid.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/lightsquid.fc
+++ serefpolicy-contrib-20140730/lightsquid.fc
@@ -1,11 +1,11 @@
 /etc/cron\.daily/lightsquid	--	gen_context(system_u:object_r:lightsquid_exec_t,s0)
 
-/usr/lib/cgi-bin/lightsquid/.*\.cfg	--	gen_context(system_u:object_r:httpd_lightsquid_content_t,s0)
-/usr/lib/cgi-bin/lightsquid/.*\.cgi	--	gen_context(system_u:object_r:httpd_lightsquid_script_exec_t,s0)
+/usr/lib/cgi-bin/lightsquid/.*\.cfg	--	gen_context(system_u:object_r:lightsquid_content_t,s0)
+/usr/lib/cgi-bin/lightsquid/.*\.cgi	--	gen_context(system_u:object_r:lightsquid_script_exec_t,s0)
 
-/usr/share/lightsquid/cgi/.*\.cgi	--	gen_context(system_u:object_r:httpd_lightsquid_script_exec_t,s0)
+/usr/share/lightsquid/cgi/.*\.cgi	--	gen_context(system_u:object_r:lightsquid_script_exec_t,s0)
 
 /var/lightsquid(/.*)?	gen_context(system_u:object_r:lightsquid_rw_content_t,s0)
 
-/var/www/html/lightsquid(/.*)?	gen_context(system_u:object_r:httpd_lightsquid_content_t,s0)
-/var/www/html/lightsquid/report(/.*)?	gen_context(system_u:object_r:lightsquid_rw_content_t,s0)
+/var/www/html/lightsquid(/.*)?	gen_context(system_u:object_r:lightsquid_content_t,s0)
+/var/www/html/lightsquid/report(/.*)?	gen_context(system_u:object_r:lightsquid_report_content_t,s0)
Index: serefpolicy-contrib-20140730/lightsquid.if
===================================================================
--- serefpolicy-contrib-20140730.orig/lightsquid.if
+++ serefpolicy-contrib-20140730/lightsquid.if
@@ -76,5 +76,7 @@ interface(`lightsquid_admin',`
 	files_search_var_lib($1)
 	admin_pattern($1, lightsquid_rw_content_t)
 
-	apache_list_sys_content($1)
+	optional_policy(`
+		apache_list_sys_content($1)
+	')
 ')
Index: serefpolicy-contrib-20140730/lightsquid.te
===================================================================
--- serefpolicy-contrib-20140730.orig/lightsquid.te
+++ serefpolicy-contrib-20140730/lightsquid.te
@@ -13,38 +13,34 @@ type lightsquid_exec_t;
 application_domain(lightsquid_t, lightsquid_exec_t)
 role lightsquid_roles types lightsquid_t;
 
-type lightsquid_rw_content_t;
-files_type(lightsquid_rw_content_t)
+type lightsquid_report_content_t;
+files_type(lightsquid_report_content_t)
 
 ########################################
 #
 # Local policy
 #
 
-manage_dirs_pattern(lightsquid_t, lightsquid_rw_content_t, lightsquid_rw_content_t)
-manage_files_pattern(lightsquid_t, lightsquid_rw_content_t, lightsquid_rw_content_t)
-manage_lnk_files_pattern(lightsquid_t, lightsquid_rw_content_t, lightsquid_rw_content_t)
-files_var_filetrans(lightsquid_t, lightsquid_rw_content_t, dir)
+manage_dirs_pattern(lightsquid_t, lightsquid_report_content_t, lightsquid_report_content_t)
+manage_files_pattern(lightsquid_t, lightsquid_report_content_t, lightsquid_report_content_t)
+manage_lnk_files_pattern(lightsquid_t, lightsquid_report_content_t, lightsquid_report_content_t)
+files_var_filetrans(lightsquid_t, lightsquid_report_content_t, dir)
 
 corecmd_exec_bin(lightsquid_t)
 corecmd_exec_shell(lightsquid_t)
 
 dev_read_urand(lightsquid_t)
 
-files_read_etc_files(lightsquid_t)
-files_read_usr_files(lightsquid_t)
-
-miscfiles_read_localization(lightsquid_t)
-
 squid_read_config(lightsquid_t)
 squid_read_log(lightsquid_t)
 
 optional_policy(`
 	apache_content_template(lightsquid)
+	apache_content_alias_template(lightsquid, lightsquid)
 
-	list_dirs_pattern(httpd_lightsquid_script_t, lightsquid_rw_content_t, lightsquid_rw_content_t)
-	read_files_pattern(httpd_lightsquid_script_t, lightsquid_rw_content_t, lightsquid_rw_content_t)
-	read_lnk_files_pattern(httpd_lightsquid_script_t, lightsquid_rw_content_t, lightsquid_rw_content_t)
+	list_dirs_pattern(lightsquid_script_t, lightsquid_report_content_t, lightsquid_report_content_t)
+	read_files_pattern(lightsquid_script_t, lightsquid_report_content_t, lightsquid_report_content_t)
+	read_lnk_files_pattern(lightsquid_script_t, lightsquid_report_content_t, lightsquid_report_content_t)
 ')
 
 optional_policy(`
